=== source/blender/draw/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2016 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  PUBLIC .
  intern

  ../editors/include
  ../editors/space_view3d
  ../gpu/intern
  ../makesrna
  ../render/intern
  ../compositor
  ../compositor/algorithms
  ../compositor/cached_resources
  ../compositor/derived_resources

  ../../../intern/opensubdiv
)

set(INC_SYS
)

set(SRC
  intern/attribute_convert.cc
  intern/draw_cache.cc
  intern/draw_cache_extract_mesh.cc
  intern/draw_cache_extract_mesh_render_data.cc
  intern/mesh_extractors/extract_mesh.cc
  intern/mesh_extractors/extract_mesh_ibo_edituv.cc
  intern/mesh_extractors/extract_mesh_ibo_fdots.cc
  intern/mesh_extractors/extract_mesh_ibo_lines.cc
  intern/mesh_extractors/extract_mesh_ibo_lines_adjacency.cc
  intern/mesh_extractors/extract_mesh_ibo_lines_paint_mask.cc
  intern/mesh_extractors/extract_mesh_ibo_points.cc
  intern/mesh_extractors/extract_mesh_ibo_tris.cc
  intern/mesh_extractors/extract_mesh_vbo_attributes.cc
  intern/mesh_extractors/extract_mesh_vbo_edge_fac.cc
  intern/mesh_extractors/extract_mesh_vbo_edit_data.cc
  intern/mesh_extractors/extract_mesh_vbo_edituv_data.cc
  intern/mesh_extractors/extract_mesh_vbo_edituv_stretch_angle.cc
  intern/mesh_extractors/extract_mesh_vbo_edituv_stretch_area.cc
  intern/mesh_extractors/extract_mesh_vbo_fdots_edituv_data.cc
  intern/mesh_extractors/extract_mesh_vbo_fdots_nor.cc
  intern/mesh_extractors/extract_mesh_vbo_fdots_pos.cc
  intern/mesh_extractors/extract_mesh_vbo_fdots_uv.cc
  intern/mesh_extractors/extract_mesh_vbo_lnor.cc
  intern/mesh_extractors/extract_mesh_vbo_mesh_analysis.cc
  intern/mesh_extractors/extract_mesh_vbo_orco.cc
  intern/mesh_extractors/extract_mesh_vbo_pos.cc
  intern/mesh_extractors/extract_mesh_vbo_sculpt_data.cc
  intern/mesh_extractors/extract_mesh_vbo_select_idx.cc
  intern/mesh_extractors/extract_mesh_vbo_skin_roots.cc
  intern/mesh_extractors/extract_mesh_vbo_tan.cc
  intern/mesh_extractors/extract_mesh_vbo_uv.cc
  intern/mesh_extractors/extract_mesh_vbo_vnor.cc
  intern/mesh_extractors/extract_mesh_vbo_weights.cc
  intern/draw_attributes.cc
  intern/draw_cache_impl_curve.cc
  intern/draw_cache_impl_curves.cc
  intern/draw_cache_impl_grease_pencil.cc
  intern/draw_cache_impl_lattice.cc
  intern/draw_cache_impl_mesh.cc
  intern/draw_cache_impl_particles.cc
  intern/draw_cache_impl_pointcloud.cc
  intern/draw_cache_impl_subdivision.cc
  intern/draw_cache_impl_volume.cc
  intern/draw_color_management.cc
  intern/draw_command.cc
  intern/draw_context.cc
  intern/draw_curves.cc
  intern/draw_debug.cc
  intern/draw_fluid.cc
  intern/draw_gpu_context.cc
  intern/draw_hair.cc
  intern/draw_manager.cc
  intern/draw_manager_text.cc
  intern/draw_pbvh.cc
  intern/draw_pointcloud.cc
  intern/draw_resource.cc
  intern/draw_sculpt.cc
  intern/draw_select_buffer.cc
  intern/draw_shader.cc
  intern/draw_view.cc
  intern/draw_view_c.cc
  intern/draw_view_data.cc
  intern/draw_volume.cc
  engines/compositor/compositor_engine.cc
  engines/image/image_drawing_mode.cc
  engines/image/image_engine.cc
  engines/image/image_shader.cc
  engines/eevee/eevee_ambient_occlusion.cc
  engines/eevee/eevee_camera.cc
  engines/eevee/eevee_cryptomatte.cc
  engines/eevee/eevee_depth_of_field.cc
  engines/eevee/eevee_engine.cc
  engines/eevee/eevee_film.cc
  engines/eevee/eevee_hizbuffer.cc
  engines/eevee/eevee_instance.cc
  engines/eevee/eevee_light.cc
  engines/eevee/eevee_lightcache.cc
  engines/eevee/eevee_lightprobe.cc
  engines/eevee/eevee_lightprobe_planar.cc
  engines/eevee/eevee_lightprobe_sphere.cc
  engines/eevee/eevee_lightprobe_volume.cc
  engines/eevee/eevee_lookdev.cc
  engines/eevee/eevee_lut.cc
  engines/eevee/eevee_material.cc
  engines/eevee/eevee_motion_blur.cc
  engines/eevee/eevee_pipeline.cc
  engines/eevee/eevee_precompute.cc
  engines/eevee/eevee_raytrace.cc
  engines/eevee/eevee_renderbuffers.cc
  engines/eevee/eevee_sampling.cc
  engines/eevee/eevee_shader.cc
  engines/eevee/eevee_shadow.cc
  engines/eevee/eevee_subsurface.cc
  engines/eevee/eevee_sync.cc
  engines/eevee/eevee_velocity.cc
  engines/eevee/eevee_view.cc
  engines/eevee/eevee_volume.cc
  engines/eevee/eevee_world.cc
  engines/workbench/workbench_effect_antialiasing.cc
  engines/workbench/workbench_effect_cavity.cc
  engines/workbench/workbench_effect_dof.cc
  engines/workbench/workbench_effect_outline.cc
  engines/workbench/workbench_engine.cc
  engines/workbench/workbench_materials.cc
  engines/workbench/workbench_mesh_passes.cc
  engines/workbench/workbench_resources.cc
  engines/workbench/workbench_shader_cache.cc
  engines/workbench/workbench_shadow.cc
  engines/workbench/workbench_state.cc
  engines/workbench/workbench_volume.cc
  engines/external/external_engine.cc
  engines/gpencil/gpencil_antialiasing.cc
  engines/gpencil/gpencil_cache_utils.cc
  engines/gpencil/gpencil_draw_data.cc
  engines/gpencil/gpencil_engine_c.cc
  engines/gpencil/gpencil_render.cc
  engines/gpencil/gpencil_shader_fx.cc
  engines/select/select_engine.cc
  engines/select/select_instance.cc
  engines/overlay/overlay_armature.cc
  engines/overlay/overlay_engine.cc
  engines/overlay/overlay_instance.cc
  engines/overlay/overlay_shader.cc
  engines/overlay/overlay_shape.cc

  DRW_engine.hh
  DRW_pbvh.hh
  DRW_select_buffer.hh
  intern/DRW_gpu_wrapper.hh
  intern/DRW_render.hh
  intern/attribute_convert.hh
  intern/draw_attributes.hh
  intern/draw_cache.hh
  intern/draw_cache_extract.hh
  intern/draw_cache_impl.hh
  intern/draw_cache_inline.hh
  intern/draw_color_management.hh
  intern/draw_command.hh
  intern/draw_common.hh
  intern/draw_common_c.hh
  intern/draw_context_private.hh
  intern/draw_curves_private.hh
  intern/draw_debug.hh
  intern/draw_hair_private.hh
  intern/draw_handle.hh
  intern/draw_manager.hh
  intern/draw_manager_text.hh
  intern/draw_pass.hh
  intern/draw_resource.hh
  intern/draw_sculpt.hh
  intern/draw_shader.hh
  intern/draw_shader_shared.hh
  intern/draw_state.hh
  intern/draw_subdiv_defines.hh
  intern/draw_subdiv_shader_shared.hh
  intern/draw_subdivision.hh
  intern/draw_view.hh
  intern/draw_view_c.hh
  intern/draw_view_data.hh
  intern/mesh_extractors/extract_mesh.hh
  engines/compositor/compositor_engine.h
  engines/eevee/eevee_ambient_occlusion.hh
  engines/eevee/eevee_camera.hh
  engines/eevee/eevee_cryptomatte.hh
  engines/eevee/eevee_depth_of_field.hh
  engines/eevee/eevee_engine.h
  engines/eevee/eevee_film.hh
  engines/eevee/eevee_gbuffer.hh
  engines/eevee/eevee_hizbuffer.hh
  engines/eevee/eevee_instance.hh
  engines/eevee/eevee_light.hh
  engines/eevee/eevee_lightcache.hh
  engines/eevee/eevee_lightprobe.hh
  engines/eevee/eevee_lightprobe_planar.hh
  engines/eevee/eevee_lightprobe_sphere.hh
  engines/eevee/eevee_lightprobe_volume.hh
  engines/eevee/eevee_lookdev.hh
  engines/eevee/eevee_lut.hh
  engines/eevee/eevee_material.hh
  engines/eevee/eevee_motion_blur.hh
  engines/eevee/eevee_pipeline.hh
  engines/eevee/eevee_precompute.hh
  engines/eevee/eevee_raytrace.hh
  engines/eevee/eevee_renderbuffers.hh
  engines/eevee/eevee_sampling.hh
  engines/eevee/eevee_shader.hh
  engines/eevee/eevee_shadow.hh
  engines/eevee/eevee_subsurface.hh
  engines/eevee/eevee_sync.hh
  engines/eevee/eevee_velocity.hh
  engines/eevee/eevee_view.hh
  engines/eevee/eevee_volume.hh
  engines/eevee/eevee_world.hh
  engines/external/external_engine.h
  engines/gpencil/gpencil_engine.hh
  engines/gpencil/gpencil_engine_private.hh
  engines/gpencil/gpencil_shader.hh
  engines/image/image_batches.hh
  engines/image/image_buffer_cache.hh
  engines/image/image_drawing_mode.hh
  engines/image/image_engine.h
  engines/image/image_enums.hh
  engines/image/image_instance.hh
  engines/image/image_partial_updater.hh
  engines/image/image_private.hh
  engines/image/image_shader.hh
  engines/image/image_shader_params.hh
  engines/image/image_space.hh
  engines/image/image_space_image.hh
  engines/image/image_space_node.hh
  engines/image/image_state.hh
  engines/image/image_texture_info.hh
  engines/image/image_usage.hh
  engines/overlay/overlay_antialiasing.hh
  engines/overlay/overlay_armature.hh
  engines/overlay/overlay_attribute_text.hh
  engines/overlay/overlay_attribute_viewer.hh
  engines/overlay/overlay_axes.hh
  engines/overlay/overlay_background.hh
  engines/overlay/overlay_base.hh
  engines/overlay/overlay_bounds.hh
  engines/overlay/overlay_camera.hh
  engines/overlay/overlay_cursor.hh
  engines/overlay/overlay_curve.hh
  engines/overlay/overlay_empty.hh
  engines/overlay/overlay_engine.h
  engines/overlay/overlay_facing.hh
  engines/overlay/overlay_fade.hh
  engines/overlay/overlay_fluid.hh
  engines/overlay/overlay_force_field.hh
  engines/overlay/overlay_grease_pencil.hh
  engines/overlay/overlay_grid.hh
  engines/overlay/overlay_image.hh
  engines/overlay/overlay_instance.hh
  engines/overlay/overlay_lattice.hh
  engines/overlay/overlay_light.hh
  engines/overlay/overlay_lightprobe.hh
  engines/overlay/overlay_mesh.hh
  engines/overlay/overlay_metaball.hh
  engines/overlay/overlay_mode_transfer.hh
  engines/overlay/overlay_motion_path.hh
  engines/overlay/overlay_name.hh
  engines/overlay/overlay_origin.hh
  engines/overlay/overlay_outline.hh
  engines/overlay/overlay_paint.hh
  engines/overlay/overlay_particle.hh
  engines/overlay/overlay_pointcloud.hh
  engines/overlay/overlay_prepass.hh
  engines/overlay/overlay_private.hh
  engines/overlay/overlay_relation.hh
  engines/overlay/overlay_sculpt.hh
  engines/overlay/overlay_speaker.hh
  engines/overlay/overlay_text.hh
  engines/overlay/overlay_wireframe.hh
  engines/overlay/overlay_xray_fade.hh
  engines/select/select_defines.hh
  engines/select/select_engine.hh
  engines/select/select_instance.hh
  engines/workbench/workbench_defines.hh
  engines/workbench/workbench_engine.h
  engines/workbench/workbench_enums.hh
  engines/workbench/workbench_private.hh
  engines/workbench/workbench_shader_shared.hh
)

set(LIB
  PRIVATE bf::blenfont
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::blenloader
  PRIVATE bf::blentranslation
  PRIVATE bf::bmesh
  PRIVATE bf::depsgraph
  PRIVATE bf::dna
  PRIVATE bf::functions
  PRIVATE bf::gpu
  PRIVATE bf::imbuf
  PRIVATE bf::intern::clog
  PRIVATE bf::intern::guardedalloc
  bf_compositor
  PRIVATE bf::nodes
  PRIVATE bf::render
  PRIVATE bf::windowmanager
  PRIVATE bf::intern::atomic
  PRIVATE bf::extern::fmtlib
)

set(GLSL_SRC
  engines/eevee/shaders/eevee_ambient_occlusion_lib.glsl
  engines/eevee/shaders/eevee_ambient_occlusion_pass_comp.glsl
  engines/eevee/shaders/eevee_attributes_curves_lib.glsl
  engines/eevee/shaders/eevee_attributes_gpencil_lib.glsl
  engines/eevee/shaders/eevee_attributes_mesh_lib.glsl
  engines/eevee/shaders/eevee_attributes_pointcloud_lib.glsl
  engines/eevee/shaders/eevee_attributes_volume_lib.glsl
  engines/eevee/shaders/eevee_attributes_world_lib.glsl
  engines/eevee/shaders/eevee_bxdf_lib.glsl
  engines/eevee/shaders/eevee_bxdf_microfacet_lib.glsl
  engines/eevee/shaders/eevee_bxdf_diffuse_lib.glsl
  engines/eevee/shaders/eevee_bxdf_sampling_lib.glsl
  engines/eevee/shaders/eevee_camera_lib.glsl
  engines/eevee/shaders/eevee_closure_lib.glsl
  engines/eevee/shaders/eevee_colorspace_lib.glsl
  engines/eevee/shaders/eevee_cryptomatte_lib.glsl
  engines/eevee/shaders/eevee_debug_gbuffer_frag.glsl
  engines/eevee/shaders/eevee_debug_surfels_vert.glsl
  engines/eevee/shaders/eevee_debug_surfels_frag.glsl
  engines/eevee/shaders/eevee_debug_irradiance_grid_vert.glsl
  engines/eevee/shaders/eevee_debug_irradiance_grid_frag.glsl
  engines/eevee/shaders/eevee_deferred_capture_frag.glsl
  engines/eevee/shaders/eevee_deferred_combine_frag.glsl
  engines/eevee/shaders/eevee_deferred_thickness_amend_frag.glsl
  engines/eevee/shaders/eevee_deferred_light_frag.glsl
  engines/eevee/shaders/eevee_deferred_planar_frag.glsl
  engines/eevee/shaders/eevee_deferred_tile_classify_frag.glsl
  engines/eevee/shaders/eevee_depth_of_field_accumulator_lib.glsl
